Index: /cpp/tests/geometry_goals/apices.goal
===================================================================
--- /cpp/tests/geometry_goals/apices.goal	(revision 1174)
+++ /cpp/tests/geometry_goals/apices.goal	(revision 1175)
@@ -106,103 +106,103 @@
 j:0, 2, sh=1
 j:0, 3, sh=1
-j:0, 4, sh=1
-j:0, 5, sh=1
-j:0, 6, sh=1
-j:0, 7, sh=1
-j:0, 8, sh=1
-j:0, 9, sh=1
-j:0, 10, sh=1
-j:0, 11, sh=1
-j:0, 12, sh=1
-j:0, 13, sh=1
-j:0, 14, sh=1
-j:0, 15, sh=1
-j:0, 16, sh=1
-j:0, 17, sh=1
-j:0, 18, sh=1
-j:0, 19, sh=1
-j:0, 20, sh=1
-j:0, 21, sh=1
-j:0, 22, sh=1
-j:0, 23, sh=1
-j:0, 24, sh=1
-j:0, 25, sh=1
-j:0, 26, sh=1
-j:0, 27, sh=1
-j:0, 28, sh=1
-j:0, 29, sh=1
-j:0, 30, sh=1
-j:0, 31, sh=1
-j:0, 32, sh=1
-j:0, 33, sh=1
-j:0, 34, sh=1
-j:0, 35, sh=1
-j:0, 36, sh=1
-j:0, 37, sh=1
-j:0, 38, sh=1
-j:0, 39, sh=1
-j:0, 40, sh=1
-j:0, 41, sh=1
-j:0, 42, sh=1
-j:0, 43, sh=1
-j:0, 44, sh=1
-j:0, 45, sh=1
-j:0, 46, sh=1
-j:0, 47, sh=1
-j:0, 48, sh=1
-j:0, 49, sh=1
-j:0, 50, sh=1
-j:0, 51, sh=1
-j:0, 52, sh=1
-j:0, 53, sh=1
-j:0, 54, sh=1
-j:0, 55, sh=1
-j:0, 56, sh=1
-j:0, 57, sh=1
-j:0, 58, sh=1
-j:0, 59, sh=1
-j:0, 60, sh=1
-j:0, 61, sh=1
-j:0, 62, sh=1
-j:0, 63, sh=1
-j:0, 64, sh=1
-j:0, 65, sh=1
-j:0, 66, sh=1
-j:0, 67, sh=1
-j:0, 68, sh=1
-j:0, 69, sh=1
-j:0, 70, sh=1
-j:0, 71, sh=1
-j:0, 72, sh=1
-j:0, 73, sh=1
-j:0, 74, sh=1
-j:0, 75, sh=1
-j:0, 76, sh=1
-j:0, 77, sh=1
-j:0, 78, sh=1
-j:0, 79, sh=1
-j:0, 80, sh=1
-j:0, 81, sh=1
-j:0, 82, sh=1
-j:0, 83, sh=1
-j:0, 84, sh=1
-j:0, 85, sh=1
-j:0, 86, sh=1
-j:0, 87, sh=1
-j:0, 88, sh=1
-j:0, 89, sh=1
-j:0, 90, sh=1
-j:0, 91, sh=1
-j:0, 92, sh=1
-j:0, 93, sh=1
-j:0, 94, sh=1
-j:0, 95, sh=1
-j:0, 96, sh=1
-j:0, 97, sh=1
-j:0, 98, sh=1
-j:0, 99, sh=1
-j:0, 100, sh=1
-j:0, 101, sh=1
-j:0, 102, sh=1
+j:3, 4, sh=1
+j:4, 5, sh=1
+j:5, 6, sh=1
+j:6, 7, sh=1
+j:7, 8, sh=1
+j:8, 9, sh=1
+j:9, 10, sh=1
+j:10, 11, sh=1
+j:11, 12, sh=1
+j:12, 13, sh=1
+j:13, 14, sh=1
+j:14, 15, sh=1
+j:15, 16, sh=1
+j:16, 17, sh=1
+j:17, 18, sh=1
+j:18, 19, sh=1
+j:19, 20, sh=1
+j:20, 21, sh=1
+j:21, 22, sh=1
+j:22, 23, sh=1
+j:23, 24, sh=1
+j:24, 25, sh=1
+j:25, 26, sh=1
+j:26, 27, sh=1
+j:27, 28, sh=1
+j:28, 29, sh=1
+j:29, 30, sh=1
+j:30, 31, sh=1
+j:31, 32, sh=1
+j:32, 33, sh=1
+j:33, 34, sh=1
+j:34, 35, sh=1
+j:35, 36, sh=1
+j:36, 37, sh=1
+j:37, 38, sh=1
+j:38, 39, sh=1
+j:39, 40, sh=1
+j:40, 41, sh=1
+j:41, 42, sh=1
+j:42, 43, sh=1
+j:43, 44, sh=1
+j:44, 45, sh=1
+j:45, 46, sh=1
+j:46, 47, sh=1
+j:47, 48, sh=1
+j:48, 49, sh=1
+j:49, 50, sh=1
+j:50, 51, sh=1
+j:51, 52, sh=1
+j:52, 53, sh=1
+j:53, 54, sh=1
+j:54, 55, sh=1
+j:55, 56, sh=1
+j:56, 57, sh=1
+j:57, 58, sh=1
+j:58, 59, sh=1
+j:59, 60, sh=1
+j:60, 61, sh=1
+j:61, 62, sh=1
+j:62, 63, sh=1
+j:63, 64, sh=1
+j:64, 65, sh=1
+j:65, 66, sh=1
+j:66, 67, sh=1
+j:67, 68, sh=1
+j:68, 69, sh=1
+j:69, 70, sh=1
+j:70, 71, sh=1
+j:71, 72, sh=1
+j:72, 73, sh=1
+j:73, 74, sh=1
+j:74, 75, sh=1
+j:75, 76, sh=1
+j:76, 77, sh=1
+j:77, 78, sh=1
+j:78, 79, sh=1
+j:79, 80, sh=1
+j:80, 81, sh=1
+j:81, 82, sh=1
+j:82, 83, sh=1
+j:83, 84, sh=1
+j:84, 85, sh=1
+j:85, 86, sh=1
+j:86, 87, sh=1
+j:87, 88, sh=1
+j:88, 89, sh=1
+j:89, 90, sh=1
+j:90, 91, sh=1
+j:91, 92, sh=1
+j:92, 93, sh=1
+j:93, 94, sh=1
+j:94, 95, sh=1
+j:95, 96, sh=1
+j:96, 97, sh=1
+j:97, 98, sh=1
+j:98, 99, sh=1
+j:99, 100, sh=1
+j:100, 101, sh=1
+j:101, 102, sh=1
 
 
Index: /cpp/tests/geometry_goals/cuboid-linux.goal
===================================================================
--- /cpp/tests/geometry_goals/cuboid-linux.goal	(revision 1174)
+++ /cpp/tests/geometry_goals/cuboid-linux.goal	(revision 1175)
@@ -22,12 +22,12 @@
 j:0, 2, sh=1
 j:0, 3, sh=1
-j:0, 4, sh=1
-j:0, 5, sh=1
-j:0, 6, sh=1
-j:0, 7, sh=1
-j:0, 8, sh=1
-j:0, 9, sh=1
-j:0, 10, sh=1
-j:0, 11, sh=1
+j:3, 4, sh=1
+j:4, 5, sh=1
+j:5, 6, sh=1
+j:6, 7, sh=1
+j:7, 8, sh=1
+j:8, 9, sh=1
+j:9, 10, sh=1
+j:10, 11, sh=1
 j:0, 12, sh=1
 j:0, 13, sh=1
Index: /cpp/tests/geometry_goals/cuboid.goal
===================================================================
--- /cpp/tests/geometry_goals/cuboid.goal	(revision 1174)
+++ /cpp/tests/geometry_goals/cuboid.goal	(revision 1175)
@@ -19,12 +19,12 @@
 j:0, 2, sh=1
 j:0, 3, sh=1
-j:0, 4, sh=1
-j:0, 5, sh=1
-j:0, 6, sh=1
-j:0, 7, sh=1
-j:0, 8, sh=1
-j:0, 9, sh=1
-j:0, 10, sh=1
-j:0, 11, sh=1
+j:3, 4, sh=1
+j:4, 5, sh=1
+j:5, 6, sh=1
+j:6, 7, sh=1
+j:7, 8, sh=1
+j:8, 9, sh=1
+j:9, 10, sh=1
+j:10, 11, sh=1
 j:0, 12, sh=1
 j:0, 13, sh=1
Index: /cpp/tests/geometry_goals/cuboid_cylinder.goal
===================================================================
--- /cpp/tests/geometry_goals/cuboid_cylinder.goal	(revision 1174)
+++ /cpp/tests/geometry_goals/cuboid_cylinder.goal	(revision 1175)
@@ -20,12 +20,12 @@
 j:0, 2, sh=1
 j:0, 3, sh=1
-j:0, 4, sh=1
-j:0, 5, sh=1
-j:0, 6, sh=1
-j:0, 7, sh=1
-j:0, 8, sh=1
-j:0, 9, sh=1
-j:0, 10, sh=1
-j:0, 11, sh=1
+j:3, 4, sh=1
+j:4, 5, sh=1
+j:5, 6, sh=1
+j:6, 7, sh=1
+j:7, 8, sh=1
+j:8, 9, sh=1
+j:9, 10, sh=1
+j:10, 11, sh=1
 j:0, 12, sh=1
 j:0, 13, sh=1
Index: /cpp/tests/geometry_goals/cuboid_ellipsoid.goal
===================================================================
--- /cpp/tests/geometry_goals/cuboid_ellipsoid.goal	(revision 1174)
+++ /cpp/tests/geometry_goals/cuboid_ellipsoid.goal	(revision 1175)
@@ -20,12 +20,12 @@
 j:0, 2, sh=1
 j:0, 3, sh=1
-j:0, 4, sh=1
-j:0, 5, sh=1
-j:0, 6, sh=1
-j:0, 7, sh=1
-j:0, 8, sh=1
-j:0, 9, sh=1
-j:0, 10, sh=1
-j:0, 11, sh=1
+j:3, 4, sh=1
+j:4, 5, sh=1
+j:5, 6, sh=1
+j:6, 7, sh=1
+j:7, 8, sh=1
+j:8, 9, sh=1
+j:9, 10, sh=1
+j:10, 11, sh=1
 j:0, 12, sh=1
 j:0, 13, sh=1
Index: /cpp/tests/geometry_goals/cylinder-linux.goal
===================================================================
--- /cpp/tests/geometry_goals/cylinder-linux.goal	(revision 1174)
+++ /cpp/tests/geometry_goals/cylinder-linux.goal	(revision 1175)
@@ -21,12 +21,12 @@
 j:0, 2, sh=1
 j:0, 3, sh=1
-j:0, 4, sh=1
-j:0, 5, sh=1
-j:0, 6, sh=1
-j:0, 7, sh=1
-j:0, 8, sh=1
-j:0, 9, sh=1
-j:0, 10, sh=1
-j:0, 11, sh=1
+j:3, 4, sh=1
+j:4, 5, sh=1
+j:5, 6, sh=1
+j:6, 7, sh=1
+j:7, 8, sh=1
+j:8, 9, sh=1
+j:9, 10, sh=1
+j:10, 11, sh=1
 j:0, 12, sh=1
 j:0, 13, sh=1
Index: /cpp/tests/geometry_goals/cylinder.goal
===================================================================
--- /cpp/tests/geometry_goals/cylinder.goal	(revision 1174)
+++ /cpp/tests/geometry_goals/cylinder.goal	(revision 1175)
@@ -19,12 +19,12 @@
 j:0, 2, sh=1
 j:0, 3, sh=1
-j:0, 4, sh=1
-j:0, 5, sh=1
-j:0, 6, sh=1
-j:0, 7, sh=1
-j:0, 8, sh=1
-j:0, 9, sh=1
-j:0, 10, sh=1
-j:0, 11, sh=1
+j:3, 4, sh=1
+j:4, 5, sh=1
+j:5, 6, sh=1
+j:6, 7, sh=1
+j:7, 8, sh=1
+j:8, 9, sh=1
+j:9, 10, sh=1
+j:10, 11, sh=1
 j:0, 12, sh=1
 j:0, 13, sh=1
Index: /cpp/tests/geometry_goals/cylinder_ellipsoid.goal
===================================================================
--- /cpp/tests/geometry_goals/cylinder_ellipsoid.goal	(revision 1174)
+++ /cpp/tests/geometry_goals/cylinder_ellipsoid.goal	(revision 1175)
@@ -20,12 +20,12 @@
 j:0, 2, sh=1
 j:0, 3, sh=1
-j:0, 4, sh=1
-j:0, 5, sh=1
-j:0, 6, sh=1
-j:0, 7, sh=1
-j:0, 8, sh=1
-j:0, 9, sh=1
-j:0, 10, sh=1
-j:0, 11, sh=1
+j:3, 4, sh=1
+j:4, 5, sh=1
+j:5, 6, sh=1
+j:6, 7, sh=1
+j:7, 8, sh=1
+j:8, 9, sh=1
+j:9, 10, sh=1
+j:10, 11, sh=1
 j:0, 12, sh=1
 j:0, 13, sh=1
Index: /cpp/tests/geometry_goals/ellipsoid-linux.goal
===================================================================
--- /cpp/tests/geometry_goals/ellipsoid-linux.goal	(revision 1174)
+++ /cpp/tests/geometry_goals/ellipsoid-linux.goal	(revision 1175)
@@ -21,12 +21,12 @@
 j:0, 2, sh=1
 j:0, 3, sh=1
-j:0, 4, sh=1
-j:0, 5, sh=1
-j:0, 6, sh=1
-j:0, 7, sh=1
-j:0, 8, sh=1
-j:0, 9, sh=1
-j:0, 10, sh=1
-j:0, 11, sh=1
+j:3, 4, sh=1
+j:4, 5, sh=1
+j:5, 6, sh=1
+j:6, 7, sh=1
+j:7, 8, sh=1
+j:8, 9, sh=1
+j:9, 10, sh=1
+j:10, 11, sh=1
 j:0, 12, sh=1
 j:0, 13, sh=1
Index: /cpp/tests/geometry_goals/ellipsoid.goal
===================================================================
--- /cpp/tests/geometry_goals/ellipsoid.goal	(revision 1174)
+++ /cpp/tests/geometry_goals/ellipsoid.goal	(revision 1175)
@@ -19,12 +19,12 @@
 j:0, 2, sh=1
 j:0, 3, sh=1
-j:0, 4, sh=1
-j:0, 5, sh=1
-j:0, 6, sh=1
-j:0, 7, sh=1
-j:0, 8, sh=1
-j:0, 9, sh=1
-j:0, 10, sh=1
-j:0, 11, sh=1
+j:3, 4, sh=1
+j:4, 5, sh=1
+j:5, 6, sh=1
+j:6, 7, sh=1
+j:7, 8, sh=1
+j:8, 9, sh=1
+j:9, 10, sh=1
+j:10, 11, sh=1
 j:0, 12, sh=1
 j:0, 13, sh=1
Index: /cpp/tests/geometry_goals/f1.goal
===================================================================
--- /cpp/tests/geometry_goals/f1.goal	(revision 1174)
+++ /cpp/tests/geometry_goals/f1.goal	(revision 1175)
@@ -27,12 +27,12 @@
 j:0, 2, sh=1
 j:0, 3, sh=1
-j:0, 4, sh=1
-j:0, 5, sh=1
-j:0, 6, sh=1
-j:0, 7, sh=1
-j:0, 8, sh=1
-j:0, 9, sh=1
-j:0, 10, sh=1
-j:0, 11, sh=1
+j:3, 4, sh=1
+j:4, 5, sh=1
+j:5, 6, sh=1
+j:6, 7, sh=1
+j:7, 8, sh=1
+j:8, 9, sh=1
+j:9, 10, sh=1
+j:10, 11, sh=1
 j:0, 12, sh=1
 j:0, 13, sh=1
Index: /cpp/tests/geometry_goals/surface.goal
===================================================================
--- /cpp/tests/geometry_goals/surface.goal	(revision 1174)
+++ /cpp/tests/geometry_goals/surface.goal	(revision 1175)
@@ -228,225 +228,225 @@
 j:0, 2, sh=1
 j:0, 3, sh=1
-j:0, 4, sh=1
-j:0, 5, sh=1
-j:0, 6, sh=1
-j:0, 7, sh=1
-j:0, 8, sh=1
-j:0, 9, sh=1
-j:0, 10, sh=1
-j:0, 11, sh=1
-j:0, 12, sh=1
-j:0, 13, sh=1
-j:0, 14, sh=1
-j:0, 15, sh=1
-j:0, 16, sh=1
-j:0, 17, sh=1
-j:0, 18, sh=1
-j:0, 19, sh=1
-j:0, 20, sh=1
-j:0, 21, sh=1
-j:0, 22, sh=1
-j:0, 23, sh=1
-j:0, 24, sh=1
-j:0, 25, sh=1
-j:0, 26, sh=1
-j:0, 27, sh=1
-j:0, 28, sh=1
-j:0, 29, sh=1
-j:0, 30, sh=1
-j:0, 31, sh=1
-j:0, 32, sh=1
-j:0, 33, sh=1
-j:0, 34, sh=1
-j:0, 35, sh=1
-j:0, 36, sh=1
-j:0, 37, sh=1
-j:0, 38, sh=1
-j:0, 39, sh=1
-j:0, 40, sh=1
-j:0, 41, sh=1
-j:0, 42, sh=1
-j:0, 43, sh=1
-j:0, 44, sh=1
-j:0, 45, sh=1
-j:0, 46, sh=1
-j:0, 47, sh=1
-j:0, 48, sh=1
-j:0, 49, sh=1
-j:0, 50, sh=1
-j:0, 51, sh=1
-j:0, 52, sh=1
-j:0, 53, sh=1
-j:0, 54, sh=1
-j:0, 55, sh=1
-j:0, 56, sh=1
-j:0, 57, sh=1
-j:0, 58, sh=1
-j:0, 59, sh=1
-j:0, 60, sh=1
-j:0, 61, sh=1
-j:0, 62, sh=1
-j:0, 63, sh=1
-j:0, 64, sh=1
-j:0, 65, sh=1
-j:0, 66, sh=1
-j:0, 67, sh=1
-j:0, 68, sh=1
-j:0, 69, sh=1
-j:0, 70, sh=1
-j:0, 71, sh=1
-j:0, 72, sh=1
-j:0, 73, sh=1
-j:0, 74, sh=1
-j:0, 75, sh=1
-j:0, 76, sh=1
-j:0, 77, sh=1
-j:0, 78, sh=1
-j:0, 79, sh=1
-j:0, 80, sh=1
-j:0, 81, sh=1
-j:0, 82, sh=1
-j:0, 83, sh=1
-j:0, 84, sh=1
-j:0, 85, sh=1
-j:0, 86, sh=1
-j:0, 87, sh=1
-j:0, 88, sh=1
-j:0, 89, sh=1
-j:0, 90, sh=1
-j:0, 91, sh=1
-j:0, 92, sh=1
-j:0, 93, sh=1
-j:0, 94, sh=1
-j:0, 95, sh=1
-j:0, 96, sh=1
-j:0, 97, sh=1
-j:0, 98, sh=1
-j:0, 99, sh=1
-j:0, 100, sh=1
-j:0, 101, sh=1
-j:0, 102, sh=1
-j:0, 103, sh=1
-j:0, 104, sh=1
-j:0, 105, sh=1
-j:0, 106, sh=1
-j:0, 107, sh=1
-j:0, 108, sh=1
-j:0, 109, sh=1
-j:0, 110, sh=1
-j:0, 111, sh=1
-j:0, 112, sh=1
-j:0, 113, sh=1
-j:0, 114, sh=1
-j:0, 115, sh=1
-j:0, 116, sh=1
-j:0, 117, sh=1
-j:0, 118, sh=1
-j:0, 119, sh=1
-j:0, 120, sh=1
-j:0, 121, sh=1
-j:0, 122, sh=1
-j:0, 123, sh=1
-j:0, 124, sh=1
-j:0, 125, sh=1
-j:0, 126, sh=1
-j:0, 127, sh=1
-j:0, 128, sh=1
-j:0, 129, sh=1
-j:0, 130, sh=1
-j:0, 131, sh=1
-j:0, 132, sh=1
-j:0, 133, sh=1
-j:0, 134, sh=1
-j:0, 135, sh=1
-j:0, 136, sh=1
-j:0, 137, sh=1
-j:0, 138, sh=1
-j:0, 139, sh=1
-j:0, 140, sh=1
-j:0, 141, sh=1
-j:0, 142, sh=1
-j:0, 143, sh=1
-j:0, 144, sh=1
-j:0, 145, sh=1
-j:0, 146, sh=1
-j:0, 147, sh=1
-j:0, 148, sh=1
-j:0, 149, sh=1
-j:0, 150, sh=1
-j:0, 151, sh=1
-j:0, 152, sh=1
-j:0, 153, sh=1
-j:0, 154, sh=1
-j:0, 155, sh=1
-j:0, 156, sh=1
-j:0, 157, sh=1
-j:0, 158, sh=1
-j:0, 159, sh=1
-j:0, 160, sh=1
-j:0, 161, sh=1
-j:0, 162, sh=1
-j:0, 163, sh=1
-j:0, 164, sh=1
-j:0, 165, sh=1
-j:0, 166, sh=1
-j:0, 167, sh=1
-j:0, 168, sh=1
-j:0, 169, sh=1
-j:0, 170, sh=1
-j:0, 171, sh=1
-j:0, 172, sh=1
-j:0, 173, sh=1
-j:0, 174, sh=1
-j:0, 175, sh=1
-j:0, 176, sh=1
-j:0, 177, sh=1
-j:0, 178, sh=1
-j:0, 179, sh=1
-j:0, 180, sh=1
-j:0, 181, sh=1
-j:0, 182, sh=1
-j:0, 183, sh=1
-j:0, 184, sh=1
-j:0, 185, sh=1
-j:0, 186, sh=1
-j:0, 187, sh=1
-j:0, 188, sh=1
-j:0, 189, sh=1
-j:0, 190, sh=1
-j:0, 191, sh=1
-j:0, 192, sh=1
-j:0, 193, sh=1
-j:0, 194, sh=1
-j:0, 195, sh=1
-j:0, 196, sh=1
-j:0, 197, sh=1
-j:0, 198, sh=1
-j:0, 199, sh=1
-j:0, 200, sh=1
-j:0, 201, sh=1
-j:0, 202, sh=1
-j:0, 203, sh=1
-j:0, 204, sh=1
-j:0, 205, sh=1
-j:0, 206, sh=1
-j:0, 207, sh=1
-j:0, 208, sh=1
-j:0, 209, sh=1
-j:0, 210, sh=1
-j:0, 211, sh=1
-j:0, 212, sh=1
-j:0, 213, sh=1
-j:0, 214, sh=1
-j:0, 215, sh=1
-j:0, 216, sh=1
-j:0, 217, sh=1
-j:0, 218, sh=1
-j:0, 219, sh=1
-j:0, 220, sh=1
-j:0, 221, sh=1
-j:0, 222, sh=1
-j:0, 223, sh=1
-j:0, 224, sh=1
+j:3, 4, sh=1
+j:4, 5, sh=1
+j:5, 6, sh=1
+j:6, 7, sh=1
+j:7, 8, sh=1
+j:8, 9, sh=1
+j:9, 10, sh=1
+j:10, 11, sh=1
+j:11, 12, sh=1
+j:12, 13, sh=1
+j:13, 14, sh=1
+j:14, 15, sh=1
+j:15, 16, sh=1
+j:16, 17, sh=1
+j:17, 18, sh=1
+j:18, 19, sh=1
+j:19, 20, sh=1
+j:20, 21, sh=1
+j:21, 22, sh=1
+j:22, 23, sh=1
+j:23, 24, sh=1
+j:24, 25, sh=1
+j:25, 26, sh=1
+j:26, 27, sh=1
+j:27, 28, sh=1
+j:28, 29, sh=1
+j:29, 30, sh=1
+j:30, 31, sh=1
+j:31, 32, sh=1
+j:32, 33, sh=1
+j:33, 34, sh=1
+j:34, 35, sh=1
+j:35, 36, sh=1
+j:36, 37, sh=1
+j:37, 38, sh=1
+j:38, 39, sh=1
+j:39, 40, sh=1
+j:40, 41, sh=1
+j:41, 42, sh=1
+j:42, 43, sh=1
+j:43, 44, sh=1
+j:44, 45, sh=1
+j:45, 46, sh=1
+j:46, 47, sh=1
+j:47, 48, sh=1
+j:48, 49, sh=1
+j:49, 50, sh=1
+j:50, 51, sh=1
+j:51, 52, sh=1
+j:52, 53, sh=1
+j:53, 54, sh=1
+j:54, 55, sh=1
+j:55, 56, sh=1
+j:56, 57, sh=1
+j:57, 58, sh=1
+j:58, 59, sh=1
+j:59, 60, sh=1
+j:60, 61, sh=1
+j:61, 62, sh=1
+j:62, 63, sh=1
+j:63, 64, sh=1
+j:64, 65, sh=1
+j:65, 66, sh=1
+j:66, 67, sh=1
+j:67, 68, sh=1
+j:68, 69, sh=1
+j:69, 70, sh=1
+j:70, 71, sh=1
+j:71, 72, sh=1
+j:72, 73, sh=1
+j:73, 74, sh=1
+j:74, 75, sh=1
+j:75, 76, sh=1
+j:76, 77, sh=1
+j:77, 78, sh=1
+j:78, 79, sh=1
+j:79, 80, sh=1
+j:80, 81, sh=1
+j:81, 82, sh=1
+j:82, 83, sh=1
+j:83, 84, sh=1
+j:84, 85, sh=1
+j:85, 86, sh=1
+j:86, 87, sh=1
+j:87, 88, sh=1
+j:88, 89, sh=1
+j:89, 90, sh=1
+j:90, 91, sh=1
+j:91, 92, sh=1
+j:92, 93, sh=1
+j:93, 94, sh=1
+j:94, 95, sh=1
+j:95, 96, sh=1
+j:96, 97, sh=1
+j:97, 98, sh=1
+j:98, 99, sh=1
+j:99, 100, sh=1
+j:100, 101, sh=1
+j:101, 102, sh=1
+j:102, 103, sh=1
+j:103, 104, sh=1
+j:104, 105, sh=1
+j:105, 106, sh=1
+j:106, 107, sh=1
+j:107, 108, sh=1
+j:108, 109, sh=1
+j:109, 110, sh=1
+j:110, 111, sh=1
+j:111, 112, sh=1
+j:112, 113, sh=1
+j:113, 114, sh=1
+j:114, 115, sh=1
+j:115, 116, sh=1
+j:116, 117, sh=1
+j:117, 118, sh=1
+j:118, 119, sh=1
+j:119, 120, sh=1
+j:120, 121, sh=1
+j:121, 122, sh=1
+j:122, 123, sh=1
+j:123, 124, sh=1
+j:124, 125, sh=1
+j:125, 126, sh=1
+j:126, 127, sh=1
+j:127, 128, sh=1
+j:128, 129, sh=1
+j:129, 130, sh=1
+j:130, 131, sh=1
+j:131, 132, sh=1
+j:132, 133, sh=1
+j:133, 134, sh=1
+j:134, 135, sh=1
+j:135, 136, sh=1
+j:136, 137, sh=1
+j:137, 138, sh=1
+j:138, 139, sh=1
+j:139, 140, sh=1
+j:140, 141, sh=1
+j:141, 142, sh=1
+j:142, 143, sh=1
+j:143, 144, sh=1
+j:144, 145, sh=1
+j:145, 146, sh=1
+j:146, 147, sh=1
+j:147, 148, sh=1
+j:148, 149, sh=1
+j:149, 150, sh=1
+j:150, 151, sh=1
+j:151, 152, sh=1
+j:152, 153, sh=1
+j:153, 154, sh=1
+j:154, 155, sh=1
+j:155, 156, sh=1
+j:156, 157, sh=1
+j:157, 158, sh=1
+j:158, 159, sh=1
+j:159, 160, sh=1
+j:160, 161, sh=1
+j:161, 162, sh=1
+j:162, 163, sh=1
+j:163, 164, sh=1
+j:164, 165, sh=1
+j:165, 166, sh=1
+j:166, 167, sh=1
+j:167, 168, sh=1
+j:168, 169, sh=1
+j:169, 170, sh=1
+j:170, 171, sh=1
+j:171, 172, sh=1
+j:172, 173, sh=1
+j:173, 174, sh=1
+j:174, 175, sh=1
+j:175, 176, sh=1
+j:176, 177, sh=1
+j:177, 178, sh=1
+j:178, 179, sh=1
+j:179, 180, sh=1
+j:180, 181, sh=1
+j:181, 182, sh=1
+j:182, 183, sh=1
+j:183, 184, sh=1
+j:184, 185, sh=1
+j:185, 186, sh=1
+j:186, 187, sh=1
+j:187, 188, sh=1
+j:188, 189, sh=1
+j:189, 190, sh=1
+j:190, 191, sh=1
+j:191, 192, sh=1
+j:192, 193, sh=1
+j:193, 194, sh=1
+j:194, 195, sh=1
+j:195, 196, sh=1
+j:196, 197, sh=1
+j:197, 198, sh=1
+j:198, 199, sh=1
+j:199, 200, sh=1
+j:200, 201, sh=1
+j:201, 202, sh=1
+j:202, 203, sh=1
+j:203, 204, sh=1
+j:204, 205, sh=1
+j:205, 206, sh=1
+j:206, 207, sh=1
+j:207, 208, sh=1
+j:208, 209, sh=1
+j:209, 210, sh=1
+j:210, 211, sh=1
+j:211, 212, sh=1
+j:212, 213, sh=1
+j:213, 214, sh=1
+j:214, 215, sh=1
+j:215, 216, sh=1
+j:216, 217, sh=1
+j:217, 218, sh=1
+j:218, 219, sh=1
+j:219, 220, sh=1
+j:220, 221, sh=1
+j:221, 222, sh=1
+j:222, 223, sh=1
+j:223, 224, sh=1
 
 
Index: /cpp/tests/geometry_goals/volume.goal
===================================================================
--- /cpp/tests/geometry_goals/volume.goal	(revision 1174)
+++ /cpp/tests/geometry_goals/volume.goal	(revision 1175)
@@ -21,18 +21,18 @@
 j:0, 2, sh=1
 j:0, 3, sh=1
-j:0, 4, sh=1
-j:0, 5, sh=1
-j:0, 6, sh=1
-j:0, 7, sh=1
-j:0, 8, sh=1
-j:0, 9, sh=1
-j:0, 10, sh=1
-j:0, 11, sh=1
-j:0, 12, sh=1
-j:0, 13, sh=1
-j:0, 14, sh=1
-j:0, 15, sh=1
-j:0, 16, sh=1
-j:0, 17, sh=1
+j:3, 4, sh=1
+j:4, 5, sh=1
+j:5, 6, sh=1
+j:6, 7, sh=1
+j:7, 8, sh=1
+j:8, 9, sh=1
+j:9, 10, sh=1
+j:10, 11, sh=1
+j:11, 12, sh=1
+j:12, 13, sh=1
+j:13, 14, sh=1
+j:14, 15, sh=1
+j:15, 16, sh=1
+j:16, 17, sh=1
 
 
Index: /cpp/tests/similarity_goals/distribution.goal
===================================================================
--- /cpp/tests/similarity_goals/distribution.goal	(revision 1174)
+++ /cpp/tests/similarity_goals/distribution.goal	(revision 1175)
@@ -1,6 +1,6 @@
-0.00	0.41	0.38	0.32	0.95	
-0.41	0.00	0.73	0.27	1.31	
-0.38	0.73	0.00	0.69	0.58	
-0.32	0.27	0.69	0.00	1.27	
-0.95	1.31	0.58	1.27	0.00	
+0.00	0.42	0.36	0.30	0.93	
+0.42	0.00	0.73	0.25	1.30	
+0.36	0.73	0.00	0.66	0.57	
+0.30	0.25	0.66	0.00	1.22	
+0.93	1.30	0.57	1.22	0.00	
 