Index: /cpp/common/nonstd_span.h
===================================================================
--- /cpp/common/nonstd_span.h	(revision 1182)
+++ /cpp/common/nonstd_span.h	(revision 1183)
@@ -13,17 +13,21 @@
 	constexpr span() noexcept
 	{
-		data_ = NULL; size_ = 0;
+		data_ = NULL;
+		size_ = 0;
 	}
 	constexpr span(ElementType* first, size_t count) noexcept
 	{
-		data_ = first; size_ = count;
+		data_ = first;
+		size_ = count;
 	}
 	constexpr span(ElementType* first, ElementType* end) noexcept
 	{
-		data_ = first; size_ = end - first;
+		data_ = first;
+		size_ = end - first;
 	}
 	template<size_t N> constexpr span(ElementType(&arr)[N]) noexcept
 	{
-		data_ = arr; size_ = N;
+		data_ = arr;
+		size_ = N;
 	}
 
Index: /cpp/frams/config/f0-SDK.def
===================================================================
--- /cpp/frams/config/f0-SDK.def	(revision 1182)
+++ /cpp/frams/config/f0-SDK.def	(revision 1183)
@@ -3,5 +3,5 @@
 GROUP(Visual)
 PROP(se,0,1024,startenergy,f,,,,startenergy)
-PROP(Vstyle,1,0,vis_style,s,0,0,,vis_style)
+PROP(Vstyle,1,0,Visual style,s,0,0,,vis_style,,``See the \"Visual style definition\" context for more information'')
 ENDCLASS
 
@@ -27,5 +27,5 @@
 PROP(rz,0,1024,rot.z,f,,,,rot.z)
 PROP(i,1,0,`info',s,,,,info)
-PROP(Vstyle,2,0,vis_style,s,0,0,part,vis_style)
+PROP(Vstyle,2,0,Visual style,s,0,0,part,vis_style,,``See the \"Visual style definition\" context for more information'')
 XPROP(vr,2,0,red component,f,0.0,1.0,0.5,vcolor.x)
 XPROP(vg,2,1024,green component,f,0.0,1.0,0.5,vcolor.y)
@@ -66,5 +66,5 @@
 PROP(stam,2,0,stamina,f,0.0,1.0,0.25,stamina)
 PROP(i,2,0,`info',s,,,,info)
-PROP(Vstyle,3,0,vis_style,s,0,0,joint,vis_style)
+PROP(Vstyle,3,0,Visual style,s,0,0,joint,vis_style,,``See the \"Visual style definition\" context for more information'')
 XPROP(vr,3,0,red component,f,0.0,1.0,0.5,vcolor.x)
 XPROP(vg,3,1024,green component,f,0.0,1.0,0.5,vcolor.y)
@@ -94,5 +94,5 @@
 PROP(stam,2,0,stamina,f,0.0,1.0,0.25,stamina)
 PROP(i,2,0,`info',s,,,,info)
-PROP(Vstyle,3,0,vis_style,s,0,0,joint,vis_style)
+PROP(Vstyle,3,0,Visual style,s,0,0,joint,vis_style,,``See the \"Visual style definition\" context for more information'')
 XPROP(vr,3,0,red component,f,0.0,1.0,0.5,vcolor.x)
 XPROP(vg,3,1024,green component,f,0.0,1.0,0.5,vcolor.y)
@@ -108,5 +108,5 @@
 PROP(d,1,0,details,s,,,N,details,GETSET)
 PROP(i,1,0,`info',s,,,,info)
-PROP(Vstyle,2,0,vis_style,s,0,0,neuro,vis_style)
+PROP(Vstyle,2,0,Visual style,s,0,0,neuro,vis_style,,``See the \"Visual style definition\" context for more information'')
 PROP(getInputCount,0,1+2,`input count',d,,,,inputCount,GETONLY)
 PROP(getInputNeuroDef,0,0,`get input neuron',p oNeuroDef(d),,,,p_getInputNeuroDef,PROCEDURE)
Index: /cpp/frams/config/f0.def
===================================================================
--- /cpp/frams/config/f0.def	(revision 1182)
+++ /cpp/frams/config/f0.def	(revision 1183)
@@ -3,5 +3,5 @@
 GROUP(Visual)
 PROP(se,0,1024,startenergy,f,,,,startenergy)
-PROP(Vstyle,1,0,vis_style,s,0,0,,vis_style)
+PROP(Vstyle,1,0,Visual style,s,0,0,,vis_style,,``See the \"Visual style definition\" context for more information'')
 ENDCLASS
 
@@ -27,5 +27,5 @@
 PROP(rz,0,1024,rot.z,f,,,,rot.z)
 PROP(i,1,0,`info',s,,,,info)
-PROP(Vstyle,2,0,vis_style,s,0,0,part,vis_style)
+PROP(Vstyle,2,0,Visual style,s,0,0,part,vis_style,,``See the \"Visual style definition\" context for more information'')
 XPROP(vr,2,0,red component,f,0.0,1.0,0.5,vcolor.x)
 XPROP(vg,2,1024,green component,f,0.0,1.0,0.5,vcolor.y)
@@ -66,5 +66,5 @@
 PROP(stam,2,0,stamina,f,0.0,1.0,0.25,stamina)
 PROP(i,2,0,`info',s,,,,info)
-PROP(Vstyle,3,0,vis_style,s,0,0,joint,vis_style)
+PROP(Vstyle,3,0,Visual style,s,0,0,joint,vis_style,,``See the \"Visual style definition\" context for more information'')
 XPROP(vr,3,0,red component,f,0.0,1.0,0.5,vcolor.x)
 XPROP(vg,3,1024,green component,f,0.0,1.0,0.5,vcolor.y)
@@ -94,5 +94,5 @@
 PROP(stam,2,0,stamina,f,0.0,1.0,0.25,stamina)
 PROP(i,2,0,`info',s,,,,info)
-PROP(Vstyle,3,0,vis_style,s,0,0,joint,vis_style)
+PROP(Vstyle,3,0,Visual style,s,0,0,joint,vis_style,,``See the \"Visual style definition\" context for more information'')
 XPROP(vr,3,0,red component,f,0.0,1.0,0.5,vcolor.x)
 XPROP(vg,3,1024,green component,f,0.0,1.0,0.5,vcolor.y)
@@ -108,5 +108,5 @@
 PROP(d,1,0,details,s,,,N,details,GETSET)
 PROP(i,1,0,`info',s,,,,info)
-PROP(Vstyle,2,0,vis_style,s,0,0,neuro,vis_style)
+PROP(Vstyle,2,0,Visual style,s,0,0,neuro,vis_style,,``See the \"Visual style definition\" context for more information'')
 PROP(getInputCount,0,1+2,`input count',d,,,,inputCount,GETONLY)
 PROP(getInputNeuroDef,0,0,`get input neuron',p oNeuroDef(d),,,,p_getInputNeuroDef,PROCEDURE)
Index: /cpp/frams/genetics/genoconv.cpp
===================================================================
--- /cpp/frams/genetics/genoconv.cpp	(revision 1182)
+++ /cpp/frams/genetics/genoconv.cpp	(revision 1183)
@@ -19,5 +19,5 @@
 ///////////////////////////////////////////////////////////////////////////
 
-GenoConvParam::GenoConvParam(GenoConvManager *g) :Param(0), gcm(g)
+GenoConvParam::GenoConvParam(GenoConvManager *g) :Param(), gcm(g)
 {
 	updatetab();
Index: /cpp/frams/model/defassign-f0-SDK.h
===================================================================
--- /cpp/frams/model/defassign-f0-SDK.h	(revision 1182)
+++ /cpp/frams/model/defassign-f0-SDK.h	(revision 1183)
@@ -1,4 +1,4 @@
 // This file is a part of Framsticks SDK.  http://www.framsticks.com/
-// Copyright (C) 1999-2021  Maciej Komosinski and Szymon Ulatowski.
+// Copyright (C) 1999-2022  Maciej Komosinski and Szymon Ulatowski.
 // See LICENSE.txt for details.
 
Index: /cpp/frams/model/f0-SDK-classes.h
===================================================================
--- /cpp/frams/model/f0-SDK-classes.h	(revision 1182)
+++ /cpp/frams/model/f0-SDK-classes.h	(revision 1183)
@@ -10,5 +10,5 @@
  {"Visual",},
  {"se",0,1024,"startenergy","f",FIELD(startenergy),},
- {"Vstyle",1,0,"vis_style","s 0 0 ",FIELD(vis_style),},
+ {"Vstyle",1,0,"Visual style","s 0 0 ",FIELD(vis_style),"See the \"Visual style definition\" context for more information",},
  {0,0,0,}
 };
@@ -44,5 +44,5 @@
  {"rz",0,1024,"rot.z","f",FIELD(rot.z),},
  {"i",1,0,"info","s",FIELD(info),},
- {"Vstyle",2,0,"vis_style","s 0 0 part",FIELD(vis_style),},
+ {"Vstyle",2,0,"Visual style","s 0 0 part",FIELD(vis_style),"See the \"Visual style definition\" context for more information",},
  {"vr",2,0,"red component","f 0.0 1.0 0.5",FIELD(vcolor.x),},
  {"vg",2,1024,"green component","f 0.0 1.0 0.5",FIELD(vcolor.y),},
@@ -111,5 +111,5 @@
  {"stam",2,0,"stamina","f 0.0 1.0 0.25",FIELD(stamina),},
  {"i",2,0,"info","s",FIELD(info),},
- {"Vstyle",3,0,"vis_style","s 0 0 joint",FIELD(vis_style),},
+ {"Vstyle",3,0,"Visual style","s 0 0 joint",FIELD(vis_style),"See the \"Visual style definition\" context for more information",},
  {"vr",3,0,"red component","f 0.0 1.0 0.5",FIELD(vcolor.x),},
  {"vg",3,1024,"green component","f 0.0 1.0 0.5",FIELD(vcolor.y),},
@@ -154,5 +154,5 @@
  {"stam",2,0,"stamina","f 0.0 1.0 0.25",FIELD(stamina),},
  {"i",2,0,"info","s",FIELD(info),},
- {"Vstyle",3,0,"vis_style","s 0 0 joint",FIELD(vis_style),},
+ {"Vstyle",3,0,"Visual style","s 0 0 joint",FIELD(vis_style),"See the \"Visual style definition\" context for more information",},
  {"vr",3,0,"red component","f 0.0 1.0 0.5",FIELD(vcolor.x),},
  {"vg",3,1024,"green component","f 0.0 1.0 0.5",FIELD(vcolor.y),},
@@ -183,5 +183,5 @@
  {"d",1,0,"details","s",GETSET(details),},
  {"i",1,0,"info","s",FIELD(info),},
- {"Vstyle",2,0,"vis_style","s 0 0 neuro",FIELD(vis_style),},
+ {"Vstyle",2,0,"Visual style","s 0 0 neuro",FIELD(vis_style),"See the \"Visual style definition\" context for more information",},
  {"getInputCount",0,1+2,"input count","d",GETONLY(inputCount),},
  {"getInputNeuroDef",0,0,"get input neuron","p oNeuroDef(d)",PROCEDURE(p_getInputNeuroDef),},
Index: /cpp/frams/model/modelobj.cpp
===================================================================
--- /cpp/frams/model/modelobj.cpp	(revision 1182)
+++ /cpp/frams/model/modelobj.cpp	(revision 1183)
@@ -9,5 +9,5 @@
 	{ "Model", 1, 21, "Model", },
 	{ "se", 0, PARAM_NOSTATIC, "startenergy", "f", FIELD(startenergy), },
-	{ "Vstyle", 0, PARAM_NOSTATIC, "vis_style", "s", FIELD(vis_style), },
+	{ "Vstyle", 0, PARAM_NOSTATIC, "Visual style", "s", FIELD(vis_style), "See the \"Visual style definition\" context for more information"},
 
 	{ "geno", 0, PARAM_NOSTATIC | PARAM_READONLY, "Geno", "oGeno", GETONLY(geno), },
Index: /framspy/frams-test.py
===================================================================
--- /framspy/frams-test.py	(revision 1182)
+++ /framspy/frams-test.py	(revision 1183)
@@ -102,5 +102,5 @@
 # sampling a Model in 3D
 geno = "RXX(X,CXXX)"
-print("\nNow build a Model from the genotype '%s' and sample it in 3D, then print a 2D projection" % geno)
+print("\nNow build a Model from the genotype '%s' and sample it in 3D, then print a 2D projection." % geno)
 import numpy as np
 