Index: framspy/evolalg_steps/examples/multicriteria.py
===================================================================
--- framspy/evolalg/examples/multicriteria.py	(revision 1182)
+++ framspy/evolalg_steps/examples/multicriteria.py	(revision 1185)
@@ -19,20 +19,20 @@
 
 from FramsticksLib import FramsticksLib
-from evolalg.base.lambda_step import LambdaStep
-from evolalg.base.step import Step
-from evolalg.dissimilarity.frams_dissimilarity import FramsDissimilarity
-from evolalg.dissimilarity.levenshtein import LevenshteinDissimilarity
-from evolalg.experiment import Experiment
-from evolalg.fitness.fitness_step import FitnessStep
-from evolalg.mutation_cross.frams_cross_and_mutate import FramsCrossAndMutate
-from evolalg.population.frams_population import FramsPopulation
-from evolalg.repair.remove.field import FieldRemove
-from evolalg.repair.remove.remove import Remove
-from evolalg.selection.nsga2 import NSGA2Selection
-from evolalg.statistics.halloffame_stats import HallOfFameStatistics
-from evolalg.statistics.multistatistics_deap import MultiStatistics
-from evolalg.statistics.statistics_deap import StatisticsDeap
-from evolalg.base.union_step import UnionStep
-from evolalg.utils.population_save import PopulationSave
+from evolalg_steps.base.lambda_step import LambdaStep
+from evolalg_steps.base.step import Step
+from evolalg_steps.dissimilarity.frams_dissimilarity import FramsDissimilarity
+from evolalg_steps.dissimilarity.levenshtein import LevenshteinDissimilarity
+from evolalg_steps.experiment import Experiment
+from evolalg_steps.fitness.fitness_step import FitnessStep
+from evolalg_steps.mutation_cross.frams_cross_and_mutate import FramsCrossAndMutate
+from evolalg_steps.population.frams_population import FramsPopulation
+from evolalg_steps.repair.remove.field import FieldRemove
+from evolalg_steps.repair.remove.remove import Remove
+from evolalg_steps.selection.nsga2 import NSGA2Selection
+from evolalg_steps.statistics.halloffame_stats import HallOfFameStatistics
+from evolalg_steps.statistics.multistatistics_deap import MultiStatistics
+from evolalg_steps.statistics.statistics_deap import StatisticsDeap
+from evolalg_steps.base.union_step import UnionStep
+from evolalg_steps.utils.population_save import PopulationSave
 
 
Index: framspy/evolalg_steps/examples/niching_novelty.py
===================================================================
--- framspy/evolalg/examples/niching_novelty.py	(revision 1182)
+++ framspy/evolalg_steps/examples/niching_novelty.py	(revision 1185)
@@ -9,20 +9,20 @@
 
 from FramsticksLib import FramsticksLib
-from evolalg.base.lambda_step import LambdaStep
-from evolalg.base.step import Step
-from evolalg.dissimilarity.archive import ArchiveDissimilarity
-from evolalg.dissimilarity.frams_dissimilarity import FramsDissimilarity
-from evolalg.dissimilarity.levenshtein import LevenshteinDissimilarity
-from evolalg.experiment import Experiment
-from evolalg.fitness.fitness_step import FitnessStep
-from evolalg.mutation_cross.frams_cross_and_mutate import FramsCrossAndMutate
-from evolalg.population.frams_population import FramsPopulation
-from evolalg.repair.remove.field import FieldRemove
-from evolalg.repair.remove.remove import Remove
-from evolalg.selection.tournament import TournamentSelection
-from evolalg.statistics.halloffame_stats import HallOfFameStatistics
-from evolalg.statistics.statistics_deap import StatisticsDeap
-from evolalg.base.union_step import UnionStep
-from evolalg.utils.population_save import PopulationSave
+from evolalg_steps.base.lambda_step import LambdaStep
+from evolalg_steps.base.step import Step
+from evolalg_steps.dissimilarity.archive import ArchiveDissimilarity
+from evolalg_steps.dissimilarity.frams_dissimilarity import FramsDissimilarity
+from evolalg_steps.dissimilarity.levenshtein import LevenshteinDissimilarity
+from evolalg_steps.experiment import Experiment
+from evolalg_steps.fitness.fitness_step import FitnessStep
+from evolalg_steps.mutation_cross.frams_cross_and_mutate import FramsCrossAndMutate
+from evolalg_steps.population.frams_population import FramsPopulation
+from evolalg_steps.repair.remove.field import FieldRemove
+from evolalg_steps.repair.remove.remove import Remove
+from evolalg_steps.selection.tournament import TournamentSelection
+from evolalg_steps.statistics.halloffame_stats import HallOfFameStatistics
+from evolalg_steps.statistics.statistics_deap import StatisticsDeap
+from evolalg_steps.base.union_step import UnionStep
+from evolalg_steps.utils.population_save import PopulationSave
 
 
@@ -226,5 +226,5 @@
     if parsed_args.max_numconnections is not None:
         remove.append(NumConnectionsHigher(parsed_args.max_numconnections))
-    if parsed_args.max_numgenochars is not -1:
+    if parsed_args.max_numgenochars != -1:
         remove.append(NumCharsHigher(parsed_args.max_numgenochars))
 
Index: framspy/evolalg_steps/examples/standard.py
===================================================================
--- framspy/evolalg/examples/standard.py	(revision 1182)
+++ framspy/evolalg_steps/examples/standard.py	(revision 1185)
@@ -12,14 +12,14 @@
 
 from FramsticksLib import FramsticksLib
-from evolalg.base.union_step import UnionStep
-from evolalg.experiment import Experiment
-from evolalg.fitness.fitness_step import FitnessStep
-from evolalg.mutation_cross.frams_cross_and_mutate import FramsCrossAndMutate
-from evolalg.population.frams_population import FramsPopulation
-from evolalg.repair.remove.field import FieldRemove
-from evolalg.selection.tournament import TournamentSelection
-from evolalg.statistics.halloffame_stats import HallOfFameStatistics
-from evolalg.statistics.statistics_deap import StatisticsDeap
-from evolalg.utils.population_save import PopulationSave
+from evolalg_steps.base.union_step import UnionStep
+from evolalg_steps.experiment import Experiment
+from evolalg_steps.fitness.fitness_step import FitnessStep
+from evolalg_steps.mutation_cross.frams_cross_and_mutate import FramsCrossAndMutate
+from evolalg_steps.population.frams_population import FramsPopulation
+from evolalg_steps.repair.remove.field import FieldRemove
+from evolalg_steps.selection.tournament import TournamentSelection
+from evolalg_steps.statistics.halloffame_stats import HallOfFameStatistics
+from evolalg_steps.statistics.statistics_deap import StatisticsDeap
+from evolalg_steps.utils.population_save import PopulationSave
 
 