Index: java/Framclipse/com.framsticks.framclipse/res/framscript.xml
===================================================================
--- java/Framclipse/com.framsticks.framclipse/res/framscript.xml	(revision 1181)
+++ java/Framclipse/com.framsticks.framclipse/res/framscript.xml	(revision 1188)
@@ -27,5 +27,5 @@
 	<type name="style" context="style file">
 <description><![CDATA[General visual style properties.]]></description>
-		<element name="style" type="string" default="standard"/>
+		<element name="style" type="string" max="-1" default="standard"/>
 		<element name="name" type="string" flags="19"/>
 		<element name="info" type="string" flags="19"/>
@@ -1978,11 +1978,11 @@
 			<description><![CDATA[If active, the amount of linear mix is random in each crossover operation, so the "Fraction inherited in linear mix crossover" parameter is ignored.]]></description>
 		</element>
-		<element name="fn_mut_bound_low" type="string" default="[-10.0, -10.0]">
+		<element name="fn_mut_bound_low" type="string" max="-1" default="[-10.0, -10.0]">
 			<description><![CDATA[A vector of lower bounds (one real value for each variable)]]></description>
 		</element>
-		<element name="fn_mut_bound_high" type="string" default="[10.0, 10.0]">
+		<element name="fn_mut_bound_high" type="string" max="-1" default="[10.0, 10.0]">
 			<description><![CDATA[A vector of higher bounds (one real value for each variable)]]></description>
 		</element>
-		<element name="fn_mut_stddev" type="string" default="[0.1, 0.1]">
+		<element name="fn_mut_stddev" type="string" max="-1" default="[0.1, 0.1]">
 			<description><![CDATA[A vector of standard deviations (one real value for each variable)]]></description>
 		</element>
@@ -2538,5 +2538,7 @@
 		<element name="stam" type="float" min="0" max="1" default="0.25"/>
 		<element name="i" type="string"/>
-		<element name="Vstyle" type="string" default="joint"/>
+		<element name="Vstyle" type="string" max="-1" default="joint">
+			<description><![CDATA[See the "Visual style definition" context for more information]]></description>
+		</element>
 		<element name="vr" type="float" min="0" max="1" default="0.5"/>
 		<element name="vg" type="float" min="0" max="1" default="0.5" flags="1024"/>
@@ -2780,5 +2782,7 @@
 	<type name="Model" context="Global context">
 		<element name="se" type="float" flags="256"/>
-		<element name="Vstyle" type="string" flags="256"/>
+		<element name="Vstyle" type="string" flags="256">
+			<description><![CDATA[See the "Visual style definition" context for more information]]></description>
+		</element>
 		<element name="geno" type="Geno" flags="257"/>
 		<element name="newFromString" function="true" type="Model">
@@ -3110,5 +3114,7 @@
 		<element name="d" type="string"/>
 		<element name="i" type="string"/>
-		<element name="Vstyle" type="string" default="neuro"/>
+		<element name="Vstyle" type="string" max="-1" default="neuro">
+			<description><![CDATA[See the "Visual style definition" context for more information]]></description>
+		</element>
 		<element name="getInputCount" type="integer" flags="3"/>
 		<element name="getInputNeuroDef" function="true" type="NeuroDef">
@@ -3669,5 +3675,7 @@
 		<element name="rz" type="float" flags="1024"/>
 		<element name="i" type="string"/>
-		<element name="Vstyle" type="string" default="part"/>
+		<element name="Vstyle" type="string" max="-1" default="part">
+			<description><![CDATA[See the "Visual style definition" context for more information]]></description>
+		</element>
 		<element name="vr" type="float" min="0" max="1" default="0.5"/>
 		<element name="vg" type="float" min="0" max="1" default="0.5" flags="1024"/>
@@ -3966,8 +3974,8 @@
 	</type>
 	<type name="POVExport" context="Global context">
-		<element name="povex_outdir" type="string" default=".">
+		<element name="povex_outdir" type="string" max="-1" default=".">
 			<description><![CDATA[Directory name WITHOUT trailing '/' sign]]></description>
 		</element>
-		<element name="povex_outfiles" type="string" default="scene_%04d.pov">
+		<element name="povex_outfiles" type="string" max="-1" default="scene_%04d.pov">
 			<description><![CDATA[Frame number replaces %d (eg. 'scene%03d.pov')]]></description>
 		</element>
@@ -4234,5 +4242,5 @@
 			<description><![CDATA[Resets the simulator to its default state, resets all parameters to default values and then loads this experiment definition.]]></description>
 <arguments/></element>
-		<element name="usercode" type="string" min="1">
+		<element name="usercode" type="string" min="1" max="-1">
 			<description><![CDATA[You can override any function from the original experiment definition script. Use the same function names and provide alternative implementations.
 Example:
@@ -5196,11 +5204,11 @@
 			<description><![CDATA[If active, the amount of linear mix is random in each crossover operation, so the "Fraction inherited in linear mix crossover" parameter is ignored.]]></description>
 		</element>
-		<element name="fn_mut_bound_low" type="string" default="[-10.0, -10.0]">
+		<element name="fn_mut_bound_low" type="string" max="-1" default="[-10.0, -10.0]">
 			<description><![CDATA[A vector of lower bounds (one real value for each variable)]]></description>
 		</element>
-		<element name="fn_mut_bound_high" type="string" default="[10.0, 10.0]">
+		<element name="fn_mut_bound_high" type="string" max="-1" default="[10.0, 10.0]">
 			<description><![CDATA[A vector of higher bounds (one real value for each variable)]]></description>
 		</element>
-		<element name="fn_mut_stddev" type="string" default="[0.1, 0.1]">
+		<element name="fn_mut_stddev" type="string" max="-1" default="[0.1, 0.1]">
 			<description><![CDATA[A vector of standard deviations (one real value for each variable)]]></description>
 		</element>
@@ -6058,5 +6066,5 @@
 			<description><![CDATA[Resets the simulator to its default state, resets all parameters to default values and then loads this experiment definition.]]></description>
 <arguments/></element>
-		<element name="usercode" type="string" min="1">
+		<element name="usercode" type="string" min="1" max="-1">
 			<description><![CDATA[You can override any function from the original experiment definition script. Use the same function names and provide alternative implementations.
 Example:
@@ -6599,4 +6607,6 @@
 			<description><![CDATA[String prefix used in the Framsticks file format to indicate object fields that contain serialized objects.]]></description>
 		</element>
+		<element name="ESC" type="string" flags="1"/>
+		<element name="NBSP" type="string" flags="1"/>
 	</type>
 	<type name="UserScripts" context="Global context">
@@ -6815,5 +6825,5 @@
 
 Internaly, the data returned by this function is generated by the 'scripts/worldmap-faces.script' file, so you can refer to its source if needed.
-The first argument to getAsString() (if not null or empty string) selects an alternate userscript to be used instead of the default "worldmap-faces.script", allowing for extension and customization.
+The first argument to getAsString() (if not null or empty string) selects an alternate userscript to be used instead of the default 'worldmap-faces.script', allowing for extension and customization.
 Examples:
 WorldMap.getAsString(null,null) //use the default script
@@ -7105,5 +7115,7 @@
 		<element name="d" type="string"/>
 		<element name="i" type="string"/>
-		<element name="Vstyle" type="string" default="neuro"/>
+		<element name="Vstyle" type="string" max="-1" default="neuro">
+			<description><![CDATA[See the "Visual style definition" context for more information]]></description>
+		</element>
 		<element name="getInputCount" type="integer" flags="3"/>
 		<element name="getInputNeuroDef" function="true" type="NeuroDef">
@@ -7910,5 +7922,7 @@
 		<element name="stam" type="float" min="0" max="1" default="0.25"/>
 		<element name="i" type="string"/>
-		<element name="Vstyle" type="string" default="joint"/>
+		<element name="Vstyle" type="string" max="-1" default="joint">
+			<description><![CDATA[See the "Visual style definition" context for more information]]></description>
+		</element>
 		<element name="vr" type="float" min="0" max="1" default="0.5"/>
 		<element name="vg" type="float" min="0" max="1" default="0.5" flags="1024"/>
@@ -7923,5 +7937,7 @@
 	<type name="m" context="Visual style definition">
 		<element name="se" type="float" flags="1024"/>
-		<element name="Vstyle" type="string"/>
+		<element name="Vstyle" type="string" max="-1">
+			<description><![CDATA[See the "Visual style definition" context for more information]]></description>
+		</element>
 	</type>
 	<type name="Material" context="Visual style definition">
@@ -7978,5 +7994,7 @@
 		<element name="d" type="string"/>
 		<element name="i" type="string"/>
-		<element name="Vstyle" type="string" default="neuro"/>
+		<element name="Vstyle" type="string" max="-1" default="neuro">
+			<description><![CDATA[See the "Visual style definition" context for more information]]></description>
+		</element>
 		<element name="getInputCount" type="integer" flags="3"/>
 		<element name="getInputNeuroDef" function="true" type="NeuroDef">
@@ -8018,5 +8036,7 @@
 		<element name="rz" type="float" flags="1024"/>
 		<element name="i" type="string"/>
-		<element name="Vstyle" type="string" default="part"/>
+		<element name="Vstyle" type="string" max="-1" default="part">
+			<description><![CDATA[See the "Visual style definition" context for more information]]></description>
+		</element>
 		<element name="vr" type="float" min="0" max="1" default="0.5"/>
 		<element name="vg" type="float" min="0" max="1" default="0.5" flags="1024"/>
@@ -8181,5 +8201,5 @@
 	</type>
 	<type name="VisualStyle" context="Visual style definition">
-		<element name="style" type="string" default="standard"/>
+		<element name="style" type="string" max="-1" default="standard"/>
 		<element name="name" type="string" flags="19"/>
 		<element name="info" type="string" flags="19"/>
@@ -8938,8 +8958,8 @@
 	</type>
 	<type name="ImageExport" context="Framsticks Theater">
-		<element name="imgex_outdir" type="string" default=".">
+		<element name="imgex_outdir" type="string" max="-1" default=".">
 			<description><![CDATA[Directory name WITHOUT trailing '/' sign]]></description>
 		</element>
-		<element name="imgex_outfiles" type="string" default="scene_%04d.jpg">
+		<element name="imgex_outfiles" type="string" max="-1" default="scene_%04d.jpg">
 			<description><![CDATA[Frame number replaces %d (eg. 'image%03d.jpg')]]></description>
 		</element>
@@ -9361,5 +9381,5 @@
 	</type>
 	<type name="VisualStyle" context="Framsticks Theater">
-		<element name="style" type="string" default="standard"/>
+		<element name="style" type="string" max="-1" default="standard"/>
 		<element name="name" type="string" flags="19"/>
 		<element name="info" type="string" flags="19"/>