Index: framspy/FramsticksEvolution.py
===================================================================
--- framspy/FramsticksEvolution.py	(revision 1204)
+++ framspy/FramsticksEvolution.py	(revision 1205)
@@ -142,5 +142,5 @@
 	print("Argument values:", ", ".join(['%s=%s' % (arg, getattr(parsed_args, arg)) for arg in vars(parsed_args)]))
 	OPTIMIZATION_CRITERIA = parsed_args.opt.split(",")
-	framsLib = FramsticksLib(parsed_args.path, parsed_args.lib, parsed_args.sim.split(";"))
+	framsLib = FramsticksLib(parsed_args.path, parsed_args.lib, parsed_args.sim)
 	toolbox = prepareToolbox(framsLib, OPTIMIZATION_CRITERIA, parsed_args.tournament, '1' if parsed_args.genformat is None else parsed_args.genformat, parsed_args.initialgenotype)
 	pop = toolbox.population(n=parsed_args.popsize)
Index: framspy/evolalg/run_frams_islands.py
===================================================================
--- framspy/evolalg/run_frams_islands.py	(revision 1204)
+++ framspy/evolalg/run_frams_islands.py	(revision 1205)
@@ -14,5 +14,5 @@
     opt_criteria = parsed_args.opt.split(",")
     framsLib = FramsticksLib(
-        parsed_args.path, parsed_args.lib, parsed_args.sim.split(";"))
+        parsed_args.path, parsed_args.lib, parsed_args.sim)
     constrains = {"max_numparts": parsed_args.max_numparts,
                   "max_numjoints": parsed_args.max_numjoints,
Index: framspy/evolalg/run_frams_niching.py
===================================================================
--- framspy/evolalg/run_frams_niching.py	(revision 1204)
+++ framspy/evolalg/run_frams_niching.py	(revision 1205)
@@ -14,5 +14,5 @@
     opt_criteria = parsed_args.opt.split(",")
     framsLib = FramsticksLib(
-        parsed_args.path, parsed_args.lib, parsed_args.sim.split(";"))
+        parsed_args.path, parsed_args.lib, parsed_args.sim)
     constrains = {"max_numparts": parsed_args.max_numparts,
                   "max_numjoints": parsed_args.max_numjoints,
Index: framspy/evolalg/tests/test_diferent_settings.py
===================================================================
--- framspy/evolalg/tests/test_diferent_settings.py	(revision 1204)
+++ framspy/evolalg/tests/test_diferent_settings.py	(revision 1205)
@@ -109,5 +109,5 @@
     opt_criteria = params['opt'].split(",")
     framsLib = FramsticksLib(
-        parsed_args.path, parsed_args.lib, parsed_args.sim.split(";"))
+        parsed_args.path, parsed_args.lib, parsed_args.sim)
     constrains = {"max_numparts": params['max_numparts'],
                   "max_numjoints": params['max_numjoints'],
@@ -141,5 +141,5 @@
     opt_criteria = params['opt'].split(",")
     framsLib = FramsticksLib(
-        parsed_args.path, parsed_args.lib, parsed_args.sim.split(";"))
+        parsed_args.path, parsed_args.lib, parsed_args.sim)
     constrains = {"max_numparts": params['max_numparts'],
                   "max_numjoints": params['max_numjoints'],
Index: framspy/evolalg_steps/examples/multicriteria.py
===================================================================
--- framspy/evolalg_steps/examples/multicriteria.py	(revision 1204)
+++ framspy/evolalg_steps/examples/multicriteria.py	(revision 1205)
@@ -168,5 +168,5 @@
 def create_experiment():
     parsed_args = parseArguments()
-    frams_lib = FramsticksLib(parsed_args.path, parsed_args.lib, parsed_args.sim.split(";"))
+    frams_lib = FramsticksLib(parsed_args.path, parsed_args.lib, parsed_args.sim)
 
     opt_dissim = []
Index: framspy/evolalg_steps/examples/niching_novelty.py
===================================================================
--- framspy/evolalg_steps/examples/niching_novelty.py	(revision 1204)
+++ framspy/evolalg_steps/examples/niching_novelty.py	(revision 1205)
@@ -179,6 +179,5 @@
 def create_experiment():
     parsed_args = parseArguments()
-    frams_lib = FramsticksLib(parsed_args.path, parsed_args.lib,
-                              parsed_args.sim.split(";"))
+    frams_lib = FramsticksLib(parsed_args.path, parsed_args.lib, parsed_args.sim)
     # Steps for generating first population
     init_stages = [
Index: framspy/evolalg_steps/examples/standard.py
===================================================================
--- framspy/evolalg_steps/examples/standard.py	(revision 1204)
+++ framspy/evolalg_steps/examples/standard.py	(revision 1205)
@@ -66,5 +66,5 @@
 def main():
     parsed_args = parseArguments()
-    frams_lib = FramsticksLib(parsed_args.path, parsed_args.lib, parsed_args.sim.split(";"))
+    frams_lib = FramsticksLib(parsed_args.path, parsed_args.lib, parsed_args.sim)
 
     hall_of_fame = HallOfFameStatistics(parsed_args.hof_size, "fitness")