Index: java/Framclipse/com.framsticks.framclipse/res/framscript.xml
===================================================================
--- java/Framclipse/com.framsticks.framclipse/res/framscript.xml	(revision 1188)
+++ java/Framclipse/com.framsticks.framclipse/res/framscript.xml	(revision 1222)
@@ -241,5 +241,5 @@
 		</element>
 		<element name="centerOfGravity" type="XYZ" flags="3">
-			<description><![CDATA[Only updated once every 'perfperiod' steps! See http://www.framsticks.com/a/al_params.html#exper-perfcalc]]></description>
+			<description><![CDATA[See http://www.framsticks.com/a/al_params.html#exper-perfcalc]]></description>
 		</element>
 		<element name="numparts" type="integer" flags="3"/>
@@ -1662,14 +1662,14 @@
 The i="mi=md" combination is allowed.]]></description>
 		</element>
-		<element name="f0_p_new" type="float" min="0" max="100" default="5.0">
-			<description><![CDATA[]]></description>
-		</element>
-		<element name="f0_p_del" type="float" min="0" max="100" default="5.0">
-			<description><![CDATA[]]></description>
-		</element>
-		<element name="f0_p_swp" type="float" min="0" max="100" default="10.0">
-			<description><![CDATA[]]></description>
-		</element>
-		<element name="f0_p_pos" type="float" min="0" max="100" default="10.0">
+		<element name="f0_p_new" type="float" min="0" max="100" default="4.0">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="f0_p_del" type="float" min="0" max="100" default="4.0">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="f0_p_swp" type="float" min="0" max="100" default="1.0">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="f0_p_pos" type="float" min="0" max="100" default="4.0">
 			<description><![CDATA[]]></description>
 		</element>
@@ -1677,8 +1677,8 @@
 			<description><![CDATA[Density only has an influence under water]]></description>
 		</element>
-		<element name="f0_p_frc" type="float" min="0" max="100" default="10.0">
-			<description><![CDATA[]]></description>
-		</element>
-		<element name="f0_p_ing" type="float" min="0" max="100" default="10.0">
+		<element name="f0_p_frc" type="float" min="0" max="100" default="1.0">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="f0_p_ing" type="float" min="0" max="100" default="1.0">
 			<description><![CDATA[]]></description>
 		</element>
@@ -1686,8 +1686,8 @@
 			<description><![CDATA[The interpretation and influence of this property must be implemented by the experiment definition]]></description>
 		</element>
-		<element name="f0_j_new" type="float" min="0" max="100" default="5.0">
-			<description><![CDATA[]]></description>
-		</element>
-		<element name="f0_j_del" type="float" min="0" max="100" default="5.0">
+		<element name="f0_j_new" type="float" min="0" max="100" default="3.0">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="f0_j_del" type="float" min="0" max="100" default="3.0">
 			<description><![CDATA[]]></description>
 		</element>
@@ -1695,8 +1695,8 @@
 			<description><![CDATA[The interpretation and influence of this property must be implemented by the experiment definition]]></description>
 		</element>
-		<element name="f0_j_stf" type="float" min="0" max="100" default="10.0">
-			<description><![CDATA[]]></description>
-		</element>
-		<element name="f0_j_rsf" type="float" min="0" max="100" default="10.0">
+		<element name="f0_j_stf" type="float" min="0" max="100" default="1.0">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="f0_j_rsf" type="float" min="0" max="100" default="1.0">
 			<description><![CDATA[]]></description>
 		</element>
@@ -1710,20 +1710,20 @@
 			<description><![CDATA[]]></description>
 		</element>
-		<element name="f0_n_new" type="float" min="0" max="100" default="5.0">
-			<description><![CDATA[]]></description>
-		</element>
-		<element name="f0_n_del" type="float" min="0" max="100" default="5.0">
-			<description><![CDATA[]]></description>
-		</element>
-		<element name="f0_n_prp" type="float" min="0" max="100" default="10.0">
-			<description><![CDATA[]]></description>
-		</element>
-		<element name="f0_c_new" type="float" min="0" max="100" default="5.0">
-			<description><![CDATA[]]></description>
-		</element>
-		<element name="f0_c_del" type="float" min="0" max="100" default="5.0">
-			<description><![CDATA[]]></description>
-		</element>
-		<element name="f0_c_wei" type="float" min="0" max="100" default="10.0">
+		<element name="f0_n_new" type="float" min="0" max="100" default="3.0">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="f0_n_del" type="float" min="0" max="100" default="3.0">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="f0_n_prp" type="float" min="0" max="100" default="1.0">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="f0_c_new" type="float" min="0" max="100" default="2.0">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="f0_c_del" type="float" min="0" max="100" default="2.0">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="f0_c_wei" type="float" min="0" max="100" default="2.0">
 			<description><![CDATA[]]></description>
 		</element>
@@ -1817,11 +1817,11 @@
 
 f1 uses a two-point crossing over.
-If this option is turned on, cut points will be selected proportionally to neural genes.
+If this option is turned on, cut points will be selected proportionally to neural genes in both parents, and a similar number of characters will be exchanged if possible.
 Thus, if both parents have the same number of neurons, then this will be preserved in their children.]]></description>
 		</element>
-		<element name="f1_smX" type="float" min="0" max="100" default="2.0"/>
-		<element name="f1_smJunct" type="float" min="0" max="100" default="2.0"/>
-		<element name="f1_smComma" type="float" min="0" max="100" default="0.5"/>
-		<element name="f1_smModif" type="float" min="0" max="100" default="2.5">
+		<element name="f1_smX" type="float" min="0" max="100" default="4.0"/>
+		<element name="f1_smJunct" type="float" min="0" max="100" default="1.0"/>
+		<element name="f1_smComma" type="float" min="0" max="100" default="1.0"/>
+		<element name="f1_smModif" type="float" min="0" max="100" default="4.0">
 			<description><![CDATA[Modifiers: LlRrCcQqFfMmIiEeWwAaSsDdGgBb]]></description>
 		</element>
@@ -1830,8 +1830,8 @@
 (all: LlRrCcQqFfMmIiEeWwAaSsDdGgBb)]]></description>
 		</element>
-		<element name="f1_nmNeu" type="float" min="0" max="100" default="2.0">
+		<element name="f1_nmNeu" type="float" min="0" max="100" default="4.0">
 			<description><![CDATA[Adds a (connected) neuron or removes a neuron]]></description>
 		</element>
-		<element name="f1_nmConn" type="float" min="0" max="100" default="1.5">
+		<element name="f1_nmConn" type="float" min="0" max="100" default="1.0">
 			<description><![CDATA[]]></description>
 		</element>
@@ -1839,6 +1839,6 @@
 			<description><![CDATA[]]></description>
 		</element>
-		<element name="f1_nmWei" type="float" min="0" max="100" default="1.0"/>
-		<element name="f1_nmVal" type="float" min="0" max="100" default="1.5"/>
+		<element name="f1_nmWei" type="float" min="0" max="100" default="2.0"/>
+		<element name="f1_nmVal" type="float" min="0" max="100" default="1.0"/>
 		<element name="f2_mutAddOper" type="float" min="0" max="1" default="0.4">
 			<description><![CDATA[]]></description>
@@ -1890,26 +1890,38 @@
 		</element>
 		<element name="f4_mut_add" type="float" min="0" max="100" default="50.0">
-			<description><![CDATA[mutation: probability of adding a node]]></description>
+			<description><![CDATA[Mutation: probability of adding a node]]></description>
 		</element>
 		<element name="f4_mut_add_div" type="float" min="0" max="100" default="20.0">
-			<description><![CDATA[add node mutation: probability of adding a division]]></description>
+			<description><![CDATA[Add node mutation: probability of adding a division]]></description>
 		</element>
 		<element name="f4_mut_add_conn" type="float" min="0" max="100" default="15.0">
-			<description><![CDATA[add node mutation: probability of adding a neural connection]]></description>
+			<description><![CDATA[Add node mutation: probability of adding a neural connection]]></description>
 		</element>
 		<element name="f4_mut_add_neupar" type="float" min="0" max="100" default="5.0">
-			<description><![CDATA[add node mutation: probability of adding a neuron property/modifier]]></description>
+			<description><![CDATA[Add node mutation: probability of adding a neuron property/modifier]]></description>
 		</element>
 		<element name="f4_mut_add_rep" type="float" min="0" max="100" default="10.0">
-			<description><![CDATA[add node mutation: probability of adding a repetition]]></description>
+			<description><![CDATA[Add node mutation: probability of adding a repetition]]></description>
 		</element>
 		<element name="f4_mut_add_simp" type="float" min="0" max="100" default="50.0">
-			<description><![CDATA[add node mutation: probability of adding a random, simple gene]]></description>
+			<description><![CDATA[Add node mutation: probability of adding a random, simple gene]]></description>
 		</element>
 		<element name="f4_mut_del" type="float" min="0" max="100" default="20.0">
-			<description><![CDATA[mutation: probability of deleting a node]]></description>
+			<description><![CDATA[Mutation: probability of deleting a node]]></description>
 		</element>
 		<element name="f4_mut_mod" type="float" min="0" max="100" default="30.0">
-			<description><![CDATA[mutation: probability of changing a node]]></description>
+			<description><![CDATA[Mutation: probability of changing a node]]></description>
+		</element>
+		<element name="f4_mut_modneu_type" type="float" min="0" max="100" default="10.0">
+			<description><![CDATA[Neuron mutation: probability of changing its type]]></description>
+		</element>
+		<element name="f4_mut_modneu_conn" type="float" min="0" max="100" default="30.0">
+			<description><![CDATA[Neuron mutation: probability of changing its connection]]></description>
+		</element>
+		<element name="f4_mut_modneu_weight" type="float" min="0" max="100" default="60.0">
+			<description><![CDATA[Neuron mutation: probability of changing its weight]]></description>
+		</element>
+		<element name="f4_mut_neu_nonsensors" type="float" min="0" max="100" default="100.0">
+			<description><![CDATA[[Experimental] Neuron mutation: probability of using as an input to another neuron not only sensors, but also other neurons (more diversity) that require no inputs]]></description>
 		</element>
 		<element name="f4_mut_exmod" type="string" max="30">
@@ -2774,4 +2786,6 @@
 		<element name="store" type="integer" min="0" max="2" default="0" flags="256"/>
 		<element name="error_count" type="integer" flags="257"/>
+		<element name="error_warning_count" type="integer" flags="257"/>
+		<element name="error_warning_info_count" type="integer" flags="257"/>
 		<element name="warning_count" type="integer" flags="257"/>
 		<element name="info_count" type="integer" flags="257"/>
@@ -3807,4 +3821,14 @@
 			</arguments>
 		</element>
+		<element name="canAdd" function="true" type="integer" flags="34">
+			<description><![CDATA[Check if the creature could be built from the supplied argument, as if add() was called - this is equivalent to add()ing a creature and immediately removing it, but without the side effects of onBorn().
+The mandatory second argument means: -1=obey the current simulator setting for "Don't simulate genotypes with warnings", 0=warnings during creature building are acceptable, 1=treat such warnings as a build failure (cannot add).
+Errors/warnings are emitted like in add(), unless mute=1.]]></description>
+			<arguments>
+				<argument name="Genotype object or Geno object or string genotype or CreatureSnapshot object" type="untyped"/>
+				<argument name="treat warnings as errors" type="integer"/>
+				<argument name="mute" type="integer"/>
+			</arguments>
+		</element>
 		<element name="findUID" function="true" type="integer" flags="34">
 			<arguments>
@@ -4888,14 +4912,14 @@
 The i="mi=md" combination is allowed.]]></description>
 		</element>
-		<element name="f0_p_new" type="float" min="0" max="100" default="5.0">
-			<description><![CDATA[]]></description>
-		</element>
-		<element name="f0_p_del" type="float" min="0" max="100" default="5.0">
-			<description><![CDATA[]]></description>
-		</element>
-		<element name="f0_p_swp" type="float" min="0" max="100" default="10.0">
-			<description><![CDATA[]]></description>
-		</element>
-		<element name="f0_p_pos" type="float" min="0" max="100" default="10.0">
+		<element name="f0_p_new" type="float" min="0" max="100" default="4.0">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="f0_p_del" type="float" min="0" max="100" default="4.0">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="f0_p_swp" type="float" min="0" max="100" default="1.0">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="f0_p_pos" type="float" min="0" max="100" default="4.0">
 			<description><![CDATA[]]></description>
 		</element>
@@ -4903,8 +4927,8 @@
 			<description><![CDATA[Density only has an influence under water]]></description>
 		</element>
-		<element name="f0_p_frc" type="float" min="0" max="100" default="10.0">
-			<description><![CDATA[]]></description>
-		</element>
-		<element name="f0_p_ing" type="float" min="0" max="100" default="10.0">
+		<element name="f0_p_frc" type="float" min="0" max="100" default="1.0">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="f0_p_ing" type="float" min="0" max="100" default="1.0">
 			<description><![CDATA[]]></description>
 		</element>
@@ -4912,8 +4936,8 @@
 			<description><![CDATA[The interpretation and influence of this property must be implemented by the experiment definition]]></description>
 		</element>
-		<element name="f0_j_new" type="float" min="0" max="100" default="5.0">
-			<description><![CDATA[]]></description>
-		</element>
-		<element name="f0_j_del" type="float" min="0" max="100" default="5.0">
+		<element name="f0_j_new" type="float" min="0" max="100" default="3.0">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="f0_j_del" type="float" min="0" max="100" default="3.0">
 			<description><![CDATA[]]></description>
 		</element>
@@ -4921,8 +4945,8 @@
 			<description><![CDATA[The interpretation and influence of this property must be implemented by the experiment definition]]></description>
 		</element>
-		<element name="f0_j_stf" type="float" min="0" max="100" default="10.0">
-			<description><![CDATA[]]></description>
-		</element>
-		<element name="f0_j_rsf" type="float" min="0" max="100" default="10.0">
+		<element name="f0_j_stf" type="float" min="0" max="100" default="1.0">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="f0_j_rsf" type="float" min="0" max="100" default="1.0">
 			<description><![CDATA[]]></description>
 		</element>
@@ -4936,20 +4960,20 @@
 			<description><![CDATA[]]></description>
 		</element>
-		<element name="f0_n_new" type="float" min="0" max="100" default="5.0">
-			<description><![CDATA[]]></description>
-		</element>
-		<element name="f0_n_del" type="float" min="0" max="100" default="5.0">
-			<description><![CDATA[]]></description>
-		</element>
-		<element name="f0_n_prp" type="float" min="0" max="100" default="10.0">
-			<description><![CDATA[]]></description>
-		</element>
-		<element name="f0_c_new" type="float" min="0" max="100" default="5.0">
-			<description><![CDATA[]]></description>
-		</element>
-		<element name="f0_c_del" type="float" min="0" max="100" default="5.0">
-			<description><![CDATA[]]></description>
-		</element>
-		<element name="f0_c_wei" type="float" min="0" max="100" default="10.0">
+		<element name="f0_n_new" type="float" min="0" max="100" default="3.0">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="f0_n_del" type="float" min="0" max="100" default="3.0">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="f0_n_prp" type="float" min="0" max="100" default="1.0">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="f0_c_new" type="float" min="0" max="100" default="2.0">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="f0_c_del" type="float" min="0" max="100" default="2.0">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="f0_c_wei" type="float" min="0" max="100" default="2.0">
 			<description><![CDATA[]]></description>
 		</element>
@@ -5043,11 +5067,11 @@
 
 f1 uses a two-point crossing over.
-If this option is turned on, cut points will be selected proportionally to neural genes.
+If this option is turned on, cut points will be selected proportionally to neural genes in both parents, and a similar number of characters will be exchanged if possible.
 Thus, if both parents have the same number of neurons, then this will be preserved in their children.]]></description>
 		</element>
-		<element name="f1_smX" type="float" min="0" max="100" default="2.0"/>
-		<element name="f1_smJunct" type="float" min="0" max="100" default="2.0"/>
-		<element name="f1_smComma" type="float" min="0" max="100" default="0.5"/>
-		<element name="f1_smModif" type="float" min="0" max="100" default="2.5">
+		<element name="f1_smX" type="float" min="0" max="100" default="4.0"/>
+		<element name="f1_smJunct" type="float" min="0" max="100" default="1.0"/>
+		<element name="f1_smComma" type="float" min="0" max="100" default="1.0"/>
+		<element name="f1_smModif" type="float" min="0" max="100" default="4.0">
 			<description><![CDATA[Modifiers: LlRrCcQqFfMmIiEeWwAaSsDdGgBb]]></description>
 		</element>
@@ -5056,8 +5080,8 @@
 (all: LlRrCcQqFfMmIiEeWwAaSsDdGgBb)]]></description>
 		</element>
-		<element name="f1_nmNeu" type="float" min="0" max="100" default="2.0">
+		<element name="f1_nmNeu" type="float" min="0" max="100" default="4.0">
 			<description><![CDATA[Adds a (connected) neuron or removes a neuron]]></description>
 		</element>
-		<element name="f1_nmConn" type="float" min="0" max="100" default="1.5">
+		<element name="f1_nmConn" type="float" min="0" max="100" default="1.0">
 			<description><![CDATA[]]></description>
 		</element>
@@ -5065,6 +5089,6 @@
 			<description><![CDATA[]]></description>
 		</element>
-		<element name="f1_nmWei" type="float" min="0" max="100" default="1.0"/>
-		<element name="f1_nmVal" type="float" min="0" max="100" default="1.5"/>
+		<element name="f1_nmWei" type="float" min="0" max="100" default="2.0"/>
+		<element name="f1_nmVal" type="float" min="0" max="100" default="1.0"/>
 		<element name="f2_mutAddOper" type="float" min="0" max="1" default="0.4">
 			<description><![CDATA[]]></description>
@@ -5116,26 +5140,38 @@
 		</element>
 		<element name="f4_mut_add" type="float" min="0" max="100" default="50.0">
-			<description><![CDATA[mutation: probability of adding a node]]></description>
+			<description><![CDATA[Mutation: probability of adding a node]]></description>
 		</element>
 		<element name="f4_mut_add_div" type="float" min="0" max="100" default="20.0">
-			<description><![CDATA[add node mutation: probability of adding a division]]></description>
+			<description><![CDATA[Add node mutation: probability of adding a division]]></description>
 		</element>
 		<element name="f4_mut_add_conn" type="float" min="0" max="100" default="15.0">
-			<description><![CDATA[add node mutation: probability of adding a neural connection]]></description>
+			<description><![CDATA[Add node mutation: probability of adding a neural connection]]></description>
 		</element>
 		<element name="f4_mut_add_neupar" type="float" min="0" max="100" default="5.0">
-			<description><![CDATA[add node mutation: probability of adding a neuron property/modifier]]></description>
+			<description><![CDATA[Add node mutation: probability of adding a neuron property/modifier]]></description>
 		</element>
 		<element name="f4_mut_add_rep" type="float" min="0" max="100" default="10.0">
-			<description><![CDATA[add node mutation: probability of adding a repetition]]></description>
+			<description><![CDATA[Add node mutation: probability of adding a repetition]]></description>
 		</element>
 		<element name="f4_mut_add_simp" type="float" min="0" max="100" default="50.0">
-			<description><![CDATA[add node mutation: probability of adding a random, simple gene]]></description>
+			<description><![CDATA[Add node mutation: probability of adding a random, simple gene]]></description>
 		</element>
 		<element name="f4_mut_del" type="float" min="0" max="100" default="20.0">
-			<description><![CDATA[mutation: probability of deleting a node]]></description>
+			<description><![CDATA[Mutation: probability of deleting a node]]></description>
 		</element>
 		<element name="f4_mut_mod" type="float" min="0" max="100" default="30.0">
-			<description><![CDATA[mutation: probability of changing a node]]></description>
+			<description><![CDATA[Mutation: probability of changing a node]]></description>
+		</element>
+		<element name="f4_mut_modneu_type" type="float" min="0" max="100" default="10.0">
+			<description><![CDATA[Neuron mutation: probability of changing its type]]></description>
+		</element>
+		<element name="f4_mut_modneu_conn" type="float" min="0" max="100" default="30.0">
+			<description><![CDATA[Neuron mutation: probability of changing its connection]]></description>
+		</element>
+		<element name="f4_mut_modneu_weight" type="float" min="0" max="100" default="60.0">
+			<description><![CDATA[Neuron mutation: probability of changing its weight]]></description>
+		</element>
+		<element name="f4_mut_neu_nonsensors" type="float" min="0" max="100" default="100.0">
+			<description><![CDATA[[Experimental] Neuron mutation: probability of using as an input to another neuron not only sensors, but also other neurons (more diversity) that require no inputs]]></description>
 		</element>
 		<element name="f4_mut_exmod" type="string" max="30">
@@ -7521,5 +7557,5 @@
 		</element>
 		<element name="centerOfGravity" type="XYZ" flags="3">
-			<description><![CDATA[Only updated once every 'perfperiod' steps! See http://www.framsticks.com/a/al_params.html#exper-perfcalc]]></description>
+			<description><![CDATA[See http://www.framsticks.com/a/al_params.html#exper-perfcalc]]></description>
 		</element>
 		<element name="numparts" type="integer" flags="3"/>